Unit Hex;
Interface {-----------------------------------------------------------------}
Function HexByte(B:Byte):String;{Converts a Byte to a Hex-number (160 -> A0}
Function HexWord(B:Word):String;{Converts a Word to a Hex-number (1230>04CE}
Function HexLong(B:LongInt):String;{Converts a LongInt to a Hex-number}
function Hex64(B:Int64):String;{Converts a Int64 to a Hex-number}
function HexToInt(s_in:string):Byte;{Converts a Hex-num(2 digits) to a Byte}

Implementation {------------------------------------------------------------}

Uses SysUtils;

function HexByte(B:Byte):String;
const HexChars : Array [0..$F] of Char='0123456789ABCDEF';
begin HexByte:=HexChars[b shr 4]+HexChars[b and $F];end;

function HexWord(B:Word):String;
const HexChars : Array [0..$F] of Char='0123456789ABCDEF';
begin HexWord:=HexChars[hi(b) shr 4]+HexChars[hi(b) and $F]+
               HexChars[lo(b) shr 4]+HexChars[lo(b) and $F];end;

function HexLong(B:LongInt):String;
const HexChars : Array [0..$F] of Char='0123456789ABCDEF';
begin 
  HexLong:=HexChars[(b shr 28) And $0F]+HexChars[(b shr 24) And $0F]+
           HexChars[(b shr 20) And $0F]+HexChars[(b shr 16) And $0F]+
           HexChars[(b shr 12) And $0F]+HexChars[(b shr  8) And $0F]+
           HexChars[(b shr  4) And $0F]+HexChars[ b         And $0F];end;

function Hex64(B:Int64):String;
const HexChars : Array [0..$F] of Char='0123456789ABCDEF';
begin
  Hex64:=HexChars[(b shr 60) And $0F]+HexChars[(b shr 56) And $0F]+
         HexChars[(b shr 52) And $0F]+HexChars[(b shr 48) And $0F]+
         HexChars[(b shr 44) And $0F]+HexChars[(b shr 40) And $0F]+
         HexChars[(b shr 36) And $0F]+HexChars[(b shr 32) And $0F]+
         HexChars[(b shr 28) And $0F]+HexChars[(b shr 24) And $0F]+
         HexChars[(b shr 20) And $0F]+HexChars[(b shr 16) And $0F]+
         HexChars[(b shr 12) And $0F]+HexChars[(b shr  8) And $0F]+
         HexChars[(b shr  4) And $0F]+HexChars[ b         And $0F];end;

function HexToInt(s_in:string):Byte;
var b:Byte;
    s:string;
Begin
  s:=UpperCase(s_in);
  b:=$00;
  if (Ord(s[1])>=65) and (Ord(s[1])<=70) Then
    b:=(Ord(s[1])-55) SHL 4;
  if (Ord(s[1])>=48) and (Ord(s[1])<=57) Then
    b:=(Ord(s[1])-48) SHL 4;
  if (Ord(s[2])>=65) and (Ord(s[2])<=70) Then
    b:=b+(Ord(s[2])-55);
  if (Ord(s[2])>=48) and (Ord(s[2])<=57) Then
    b:=b+(Ord(s[2])-48);
  Result:=b;
End;

Begin
End.