unit ULanguage;

interface

uses Dialogs,SysUtils,Classes,inifiles,Menus;

procedure LoadIni;
procedure LoadIni2;//Language-Credits from main-ini
procedure UnLoadIni;
procedure Translate_LiveInet;
procedure Translate_LiveInetAdd;
procedure Translate_LiveInetLOF;
procedure Translate_LiveInetCredits;
procedure Translate_LiveInetScan;

implementation

uses ULiveInet,UAdd,ULOF,UCredits,UScan;

var Lang:TMemIniFile;
    langs:TStringList;
    NoIni:Boolean;

procedure LoadIni;
var s,s2:String;
    Main:TMemIniFile;
    i,j:Integer;
Begin
  NoIni:=False;
  langs:=TStringList.Create;
  if not FileExists('Language.ini') Then
    Begin
      NoIni:=True;
      LiveInetClass.SB_Lang.Visible:=False;
      Exit;
    End;
  Getdir(0,s);
  if (s[Length(s)]<>'\') Then s:=s+'\';
  Main:=TMemIniFile.Create(s+'Language.ini');
  With Main Do
  Begin //START MAIN
  j:=ReadInteger('Main','LangCount',0);
  if (j=0) Then
    Begin
      NoIni:=True;
      LiveInetClass.SB_Lang.Visible:=False;
      Exit;
    End;
  langs.Add('Standard(English)=0');
  For i:=1 To j Do
    Begin
      s:=ReadString('Lang'+IntToStr(i),'Name','');
      s2:=ReadString('Lang'+IntToStr(i),'Filename','');
      if (s<>'') And (s2<>'') And FileExists(s2) Then
        Begin
          langs.Add(s+'='+s2);
          LiveInetClass.CbB_Lang.Items.Add(s);
        End
       Else
        Begin
          langs.Add('0=0');
          LiveInetClass.CbB_Lang.Items.Add('Invalid/Defect');
        End
    End;
  End;//MAIN END
  Main.Free;
End;

procedure LoadIni2;//Language-Credits from main-ini
var s:String;
    Main:TMemIniFile;
    i,j:Integer;
Begin
  if NoIni Then Exit;
  Getdir(0,s);
  if (s[Length(s)]<>'\') Then s:=s+'\';
  Main:=TMemIniFile.Create(s+'Language.ini');
  j:=LiveInetClass.CbB_Lang.Items.Count-1;
  For i:=1 To j Do
    LiveInetCreditClass.M_Lang.Lines.Add(Main.ReadString(
      'Lang'+IntToStr(i),'Creator','No Info'));
  Main.Free;
End;

procedure UnLoadIni;
Begin
  if Lang<>nil Then Lang.Free;
  if langs<>nil Then langs.Free;
End;

//R2S=Read To String
//This function merges multiple lines to one (with CR)
Function  R2S(section,name,def:String):String;
var s:String;
    i:Integer;
Begin
  With Lang Do
  Begin
    if ValueExists(section,name) Then
      //seem to be only ONE line...
      Result:=ReadString(section,name,'')
     Else //may be more than one line (or nothing)...
      Begin
        i:=1;
        s:='';
        While ValueExists(section,name+IntToStr(i)) Do
          Begin
            s:=s+ReadString(section,name+IntToStr(i),'')+#13;
            Inc(i);
          End;
        if (s<>'') Then
          s:=Copy(s,1,Length(s)-1)
         Else
          s:=def;
        Result:=s;
      End;
  End;
End;

Procedure SetMessages;
var s:String;
Begin
  s:='Messages';
  With LiveInetClass Do
  Begin
    msg_err_check4dvb:=R2S(s,'msg_err_check4dvb',
      'Error:CheckForDVB'+#13+
      'TechnoTrend/Siemens driver not found!');
    msg_err_startdvb:=R2S(s,'msg_err_startdvb',
      'Error:StartDVB'+#13+
      'Error while starting the'+#13+
      'TechnoTrend/Siemens driver!');
    msg_var_diseqcoff:=R2S(s,'msg_var_diseqcoff',
      'Off');
    msg_var_notavailable:=R2S(s,'msg_var_notavailable',
      'n/a');
    msg_err_setprovider:=R2S(s,'msg_err_setprovider',
      'Error:No Provider selected'+#13+
      'Please choose a provider'+#13+
      '(You can create a custom provider with "Add")');
    msg_err_invalidvalues:=R2S(s,'msg_err_invalidvalues',
      'Error:Incorrect Values'+#13+
      'Please check the values for frequency,polarization,symbolrate and LOF!');
    msg_err_senddiseqc:=R2S(s,'msg_err_senddiseqc',
      'Error:SendDiSEqC'+#13+
      'Could not send DiSEqC message!');
    msg_err_setchannel:=R2S(s,'msg_err_setchannel',
      'Error:SetChannel'+#13+
      'Please check your input-signal, frequency, polarization, symbolrate and LOF!'+#13+
      'The DVB-Card could not lock on the provider!');
    msg_err_couldnotopen:=R2S(s,'msg_err_couldnotopen',
      'Could not open file:'+#13+
      '(You should NOT delete files from Work or'+#13+
      'Out-Dir while executing!!!)');
    msg_err_couldnotcreate:=R2S(s,'msg_err_couldnotcreate',
      'Could not create file:'+#13+
      '(May be Work-Dir full (LIMIT-->32767 files)!!!)');
    msg_var_statfiletxta1:=R2S(s,'msg_var_statfiletxta1',
     'Provider:');
    msg_var_statfiletxta2:=R2S(s,'msg_var_statfiletxta2',
     'Frequency:');
    msg_var_statfiletxta3:=R2S(s,'msg_var_statfiletxta3',
      'Used PID:');
    msg_var_statfiletxtb:=R2S(s,'msg_var_statfiletxtb',
      'Filename.Ext Size  real/given      MAC-Address  Source-IP      :Port Destination-IP :Port');
    msg_var_statfilecsv:=R2S(s,'msg_var_statfilecsv',
      'Filename,SizeReal,SizeGiven,MAC-Address,Source-IP,Port,Destination-IP,Port');
    msg_var_incompletefiles:=R2S(s,'msg_var_incompletefiles',
      'Incomplete files follow:');
    msg_var_packetcount:=R2S(s,'msg_var_packetcount',
      'Packets count/used/fail(chksumError)/lost:');
    msg_var_httpcount:=R2S(s,'msg_var_httpcount',
      'HTTP-Header defect:');
    msg_var_filelistcount:=R2S(s,'msg_var_filelistcount',
      'Filelist current/max:');
    msg_var_filecount:=R2S(s,'msg_var_filecount',
      'Files count/start/done/timeout/sizeerr:');
    msg_err_selectprovider:=R2S(s,'msg_err_selectprovider',
      'Please select a provider first!');
    msg_err_setfiltera:=R2S(s,'msg_err_setfiltera',
      'Error:SetFilter_NetSystem'+#13+
      'Please check your PID number!'+#13+
      'The PID should be in range from 0 to 65535');
    msg_err_setfilterb:=R2S(s,'msg_err_setfilterb',
      'Error:SetFilter'+#13+
      'Please check your PID number!'+#13+
      'The PID should be in range from 0 to 65535');
    msg_err_setfilterc:=R2S(s,'msg_err_setfilterc',
      'Error:SetBitFilter'+#13+
      'Please check your PID and MAC number!'+#13+
      'The PID should be in range from 0 to 65535');
    msg_err_setfilterd:=R2S(s,'msg_err_setfilterd',
      'Error:SetFilter_Scan'+#13+
      'Please check your PID number!'+#13+
      'The PID should be in range from 0 to 65535');
    msg_wng_setfiltere:=R2S(s,'msg_wng_setfiltere',
      'Warning:Can''t set MAC-filter!'+#13+
      '(Maybe there is no free filter available;'+#13+
      'delete one and try again)'+#13+
      'Filter-Nr.');
    msg_err_setfilterf:=R2S(s,'msg_err_setfilterf',
      'Error:Can''t set supportfilter!'+#13+
      '(Maybe there is no free filter available)');
    msg_wng_filterexists:=R2S(s,'msg_wng_filterexists',
      'Warning:Filter already exists!'+#13+
      '(Please choose an other MAC)');
    msg_err_delfilter:=R2S(s,'msg_err_delfilter',
      'Error:DelFilter'+#13+
      'Could not delete filter!');
    msg_cfm_deleteconfig:=R2S(s,'msg_cfm_deleteconfig',
      'Delete configuration:'+#13+
      'Your current settings will be lost!'+#13+
      'Are you sure?');
    msg_err_onlydigits:=R2S(s,'msg_err_onlydigits',
      'Please enter numbers only!');
    msg_err_onlyhexvalues:=R2S(s,'msg_err_onlyhexvalues',
      'Please enter hex values (0-9,A-F) only!');
    msg_var_chooseworkdir:=R2S(s,'msg_var_chooseworkdir',
      'Choose Work-Directory:');
    msg_var_chooseoutdir:=R2S(s,'msg_var_chooseoutdir',
      'Choose Out-Directory:');
    msg_err_mintimeut:=R2S(s,'msg_err_mintimeut',
      'Please enter AT LEAST 20 seconds'+#13+
      'for file-timeout!!!!');
    msg_err_outofmem:=R2S(s,'msg_err_outofmem',
      'WARNING:Out Of Memory'+#13+
      'No more NEW entries in filelist possible!'+#13+
      '(The program still works!!!)');
    msg_wng_oldiniexists:=R2S(s,'msg_wng_oldiniexists',
      'An old "LiveINet.ini" already exists, overwrite?'+#13+
      'This file was only used for language-infos.'+#13+
      'To save your configuration you can choose'+#13+
      'one of the following options:'+#13+
      'Yes - Overwrite the file with the new data'+#13+
      'No - Reuse the file and add the configuration'+#13+
      '(Use this option if you want to use an old Linet'+#13+
      ' in the same directory)'+#13+
      'Cancel - Do NOT save/change anything');
    msg_wng_newiniexists:=R2S(s,'msg_wng_newiniexists',
      'The existing "LiveINet.ini" was created by a newer version!'+#13+
      'You may loose some settings in the new version if'+#13+
      'you save your configuration now.'+#13+
      'You have the following options:'+#13+
      'Yes - Save your configuration'+#13+
      'No - Do NOT save/change anything');
  End;
End;

procedure Translate_LiveInet;
var index,i:Integer;
    s,sect:String;
    b:Boolean;
Begin
  if Not NoIni Then
    Begin
      index:=LiveInetClass.CbB_Lang.ItemIndex;
      if Lang<>nil Then Lang.Free;
      Getdir(0,s);
      if (s[Length(s)]<>'\') Then s:=s+'\';
      if langs.Names[index]='0' Then
        s:='' //Invalid entry
       Else
        s:=s+langs.Values[langs.Names[index]];
    End
   Else s:='';//No ini present... (useing defaults)
  Lang:=TMemIniFile.Create(s);
  //Now we can try to get the language out of the file
  With LiveInetClass Do
  Begin
    //now we try to translate Captions, Hints,...
    if Not NoIni Then
      sect:=langs.Names[index]
     Else
      sect:='';
    B_startdvb.Caption:=R2S(sect,'Button_STARTDVB',
      'Start DVB-Server');
    B_startdvb.Hint:=R2S(sect,'Button_STARTDVB_INFO',
      'Click this first');
    B_save.Caption:=R2S(sect,'Button_SAVECFG',
      'Save config');
    B_save.Hint:=R2S(sect,'Button_SAVECFG_INFO',
      'Save your current configuration to file');
    B_remove.Caption:=R2S(sect,'Button_REMOVECFG',
      'Remove config');
    B_remove.Hint:=R2S(sect,'Button_REMOVECFG_INFO',
      'Remove your configuration file (BE CAREFUL ALL SETTINGS WILL BE LOST)');
    SB_exit.Caption:=R2S(sect,'Button_EXIT',
      'E&xit');
    L_LLang.Caption:=R2S(sect,'Label_LANGUAGE',
      'Language:');
    L_LStat1.Caption:=R2S(sect,'Label_STATUS1',
      'DVB-Server is not started now...');
    L_LStat2.Caption:=R2S(sect,'Label_STATUS2',
      'Provider is not set now...');
    L_LUseCard.Caption:=R2S(sect,'Label_USECARD',
      'Use Card:');
    sect:='Source-Box';
    GB_source.Caption:=R2S(sect,'Box_NAME',
      'Source-Box');
    L_LProv1.Caption:=R2S(sect,'Label_PROVIDER1',
      'Providers:');
    CbB_provider.Hint:=R2S(sect,'ComboBox_INFO',
      'Please choose a provider of your choice');
    B_add.Caption:=R2S(sect,'Button_ADD',
      'Add');
    B_add.Hint:=R2S(sect,'Button_ADD_INFO',
      'Add new provider');
    B_del.Caption:=R2S(sect,'Button_REMOVE',
      'Remove');
    B_del.Hint:=R2S(sect,'Button_REMOVE_INFO',
      'Remove selected provider');
    B_Edit.Caption:=R2S(sect,'Button_EDIT',
      'Edit');
    B_Edit.Hint:=R2S(sect,'Button_EDIT_INFO',
      'Click here to edit selected provider');
    L_LProv2.Caption:=R2S(sect,'Label_PROVIDER2',
      'Provider:');
    L_LFreq.Caption:=R2S(sect,'Label_FREQUENCY',
      'Freq.:');
    E_PID.Hint:=R2S(sect,'Edit_PID_INFO',
      'You can change the PID temporary here! (testing)');
    B_LOF.Caption:=R2S(sect,'Button_LOF',
      'LOF settings');
    B_LOF.Hint:=R2S(sect,'Button_LOF_INFO',
      'Change settings for LOF (LNB properties)');
    B_setprov.Caption:=R2S(sect,'Button_SETPROVIDER',
      'Set Provider');
    B_setprov.Hint:=R2S(sect,'Button_SETPROVIDER_INFO',
      'Click here to set provider');
    sect:='Stream-Box';
    GB_PID.Caption:=R2S(sect,'Box_NAME',
      'Stream-Box');
    B_start.Caption:=R2S(sect,'Button_STARTSTREAM',
      'Start Streaming');
    B_start.Hint:=R2S(sect,'Button_STARTSTREAM_INFO',
      'Start data livedecoding');
    B_stop.Caption:=R2S(sect,'Button_STOPSTREAM',
      'Stop Streaming');
    B_stop.Hint:=R2S(sect,'Button_STOPSTREAM_INFO',
      'Stop livedecoding');
    CkB_MAC.Caption:=R2S(sect,'CheckBox_MAC',
      'Use MAC-Filter');
    B_MACScan.Caption:=R2S(sect,'Button_MACSCAN',
      'MAC-Settings');
    CkB_SupportFilter.Caption:=R2S(sect,'CheckBox_SUPPORT_FILTER',
      'Use support filter (TT 1.23b)');
    sect:='SpeedUp-Box';
    GB_speedup.Caption:=R2S(sect,'Box_NAME',
      'SpeedUp-Box');
    GB_speedup.Hint:=R2S(sect,'Box_INFO',
      'This doesn''t change much !!!');
    CkB_dontup.Caption:=R2S(sect,'CheckBox_DONTUP',
      'Don''t update form display');
    CkB_displaystat.Caption:=R2S(sect,'CheckBox_STATOFF',
      'Switch statusdisplay off');
    sect:='Output-Box';
    GB_dir.Caption:=R2S(sect,'Box_NAME',
      'Directories/Output-Box');
    L_LWorkdir.Caption:=R2S(sect,'Label_WORKDIR',
      'Work-Directory:');
    E_dir.Hint:=R2S(sect,'Edit_WORKDIR_INFO',
      'Path of the Working-Directory');
    B_Browse1.Caption:=R2S(sect,'Button_WORKDIR',
      'Browse &workdirectory');
    L_LOutdir.Caption:=R2S(sect,'Label_OUTDIR',
      'Data-Out-Dir:');
    E_outdir.Hint:=R2S(sect,'Edit_OUTDIR_INFO',
      'Path for saving complete files');
    B_Browse2.Caption:=R2S(sect,'Button_OUTDIR',
      'Browse &outdirectory');
    CkB_incdir.Caption:=R2S(sect,'CheckBox_INCOMPLETEDIR',
      'Save Timeout-Files:');
    CkB_sort.Caption:=R2S(sect,'CheckBox_SORTMAC',
      'Sort files into MAC-Directories (\out\????????????\...)');
    CkB_fileinfo.Caption:=R2S(sect,'CheckBox_FILEINFO1',
      'Write "\out\FileInfo.txt" (Informations about original filesizes, MACs, source-IPs, destination IPs ...)');
    CkB_csv.Caption:=R2S(sect,'CheckBox_FILEINFO2',
      'Write "\out\FileInfo.CSV" (same as above but in MSExcels CSV - format)');
    sect:='Status-Box';
    GB_status.Caption:=R2S(sect,'Box_NAME',
      'Status-Box');
    L_LPacketCnt.Caption:=R2S(sect,'Label_PACKETCOUNT',
      'Packets count/used/fail/lost:');
    L_LHttpCnt.Caption:=R2S(sect,'Label_HTTPCOUNT',
      'HTTP Header defect:');
    L_LFilelistCnt.Caption:=R2S(sect,'Label_FILELISTCOUNT',
      'Filelist count: current/max:');
    L_LFileCnt.Caption:=R2S(sect,'Label_FILECOUNT',
      'Files count/started/done/timeout/sizeerr:');
    sect:='FileType-Box';
    GB_filetypes.Caption:=R2S(sect,'Box_NAME',
      'Accept Filetypes:');
    CkLB_filetypes.Hint:=R2S(sect,'Box_INFO',
      'Types are sorted by importance');
    b:=CkLB_filetypes.Checked[0];
    CkLB_filetypes.Items[0]:=R2S(sect,'X_UNKNOWNTYPE',
      'Unknown types');
    CkLB_filetypes.Checked[0]:=b;
    B_selall.Caption:=R2S(sect,'Button_SELECTALL',
      'Select all');
    B_selnone.Caption:=R2S(sect,'Button_SELECTNONE',
      'Clear all');
    s:=R2S(sect,'Label_FTC','&FTC');
    i:=Pos('&',s);
    if ((i>0) And ((i+1)<=Length(s))) Then
      A_FTC.ShortCut:=ShortCut(Word(s[i+1]),[ssAlt]);
    L_FTC.Caption:=s;
    L_FTC.Hint:=R2S(sect,'Label_FTC_INFO',
      'Click here to (de)activate the FileTypeCounter');
    sect:='File-Box';
    GB_file.Caption:=R2S(sect,'Box_NAME',
      'File-Box');
    CkB_minfile.Caption:=R2S(sect,'CheckBox_MINSIZE',
      'Write files bigger than');
    CkB_maxfile.Caption:=R2S(sect,'CheckBox_MAXSIZE',
      'Write files smaller than');
    CkB_uknfile.Caption:=R2S(sect,'CheckBox_UNKNOWN',
      'Don''t write files with unknown size');
    CkB_timeout.Caption:=R2S(sect,'CheckBox_FILETIMEOUT',
      'File-Timeout (global) min. 20');
    sect:='Expert-Box';
    GB_Expert.Caption:=R2S(sect,'Box_NAME',
      'EXPERT-Box');
    GB_Expert.Hint:=R2S(sect,'Box_INFO',
      'Change the values only if'+#13+
      'you know what you do!!!');
    CkB_LimitFilelist.Caption:=R2S(sect,'CheckBox_LIMITFILELIST1',
      'Limit Filelist to x entries:');
    CkB_chksumoff.Caption:=R2S(sect,'CheckBox_CHKSUMOFF1',
      'Chksum off');
    CkB_SrvKillOff.Caption:=R2S(sect,'CheckBox_SERVERKILLOFF',
      'Server kill off');
    CkB_AutoWorkCleanOff.Caption:=R2S(sect,'CheckBox_NOWORKCLEANUP',
      'Auto-WorkDir-Cleanup off');
    CkB_NetSysRepair.Caption:=R2S(sect,'CheckBox_NETSYSREPAIR',
      'Use NetSys repair(only TTDVB)');
    CkB_DebugChkSum.Caption:=R2S(sect,'CheckBox_DEBUGCHKSUM',
      'Use debug Chksum');
  End;
  //we should try to translate the messages,too
  SetMessages;
End;

procedure Translate_LiveInetAdd;
var sect:String;
Begin
  With LiveInetAddClass Do
  Begin
    //now we try to translate Captions, Hints,...
    sect:='Add-Dialog';
    AddCaption:=R2S(sect,'Dialog_NAME_ADD',
      'Add provider');
    EditCaption:=R2S(sect,'Dialog_NAME_EDIT',
      'Edit provider');
    CustomName:=R2S(sect,'Edit_SUGGEST_NAME',
      'Custom1');
    L_LProvname.Caption:=R2S(sect,'Label_PROVIDERNAME',
      'Provider name:');
    L_LFreq.Caption:=R2S(sect,'Label_FREQUENCY',
      'Frequency:');
    L_LPol1.Caption:=R2S(sect,'Label_POLARIZATION1',
      'Polarization:');
    L_LPol2.Caption:=R2S(sect,'Label_POLARIZATION2',
      '(enter only H or V)');
    L_LSymb.Caption:=R2S(sect,'Label_SYMBOLRATE',
      'Symbolrate:');
    CkB_DiSEqC.Caption:=R2S(sect,'CheckBox_USEDISEQC',
      'Use DiSEqC');
    GB_DiSEqC.Caption:=R2S(sect,'Box_NAME',
      'DiSEqC-Control');
    BB_OK.Caption:=R2S(sect,'Button_OK',
      'OK');
    BB_Abort.Caption:=R2S(sect,'Button_ABORT',
      'Abort');
  End;
End;

procedure Translate_LiveInetLOF;
var sect:String;
Begin
  With LiveInetLOFClass Do
  Begin
    //now we try to translate Captions, Hints,...
    sect:='LOF-Dialog';
    Caption:=R2S(sect,'Dialog_NAME',
      'LOF-Settings');
    E_LOF1.Hint:=R2S(sect,'Edit_LOF1_INFO',
      'Change this only if you know what you do!!!!');
    E_LOFSW.Hint:=R2S(sect,'Edit_LOFSW_INFO',
      'Change this only if you know what you do!!!!');
    E_LOF2.Hint:=R2S(sect,'Edit_LOF2_INFO',
      'Change this only if you know what you do!!!!');
    BB_OK.Caption:=R2S(sect,'Button_OK',
      'OK');
  End;
End;

procedure Translate_LiveInetCredits;
var sect:String;
Begin
  With LiveInetClass Do
  With LiveInetCreditClass Do
  Begin
    //now we try to translate Captions, Hints,...
    sect:='Credits-Dialog';
    Caption:=R2S(sect,'Dialog_NAME',
      'Credits');
    GB_tr.Caption:=R2S(sect,'Box_NAME_TRANSLATION',
      'Translation');
    GB_common.Caption:=R2S(sect,'Box_NAME_COMMON',
      'Common');
    L_A1.Caption:=R2S(sect,'A1',
      msg_var_notavailable);
    L_B1.Caption:=R2S(sect,'B1',
      msg_var_notavailable);
    L_B2.Caption:=R2S(sect,'B2',
      msg_var_notavailable);
    L_C1.Caption:=R2S(sect,'C1',
      msg_var_notavailable);
    L_C2.Caption:=R2S(sect,'C2',
      msg_var_notavailable);
    L_C3.Caption:=R2S(sect,'C3',
      msg_var_notavailable);
    L_C4.Caption:=R2S(sect,'C4',
      msg_var_notavailable);
    L_D1.Caption:=R2S(sect,'D1',
      msg_var_notavailable);
    L_D2.Caption:=R2S(sect,'D2',
      msg_var_notavailable);
    L_D3.Caption:=R2S(sect,'D3',
      msg_var_notavailable);
    L_D4.Caption:=R2S(sect,'D4',
      msg_var_notavailable);
    L_D5.Caption:=R2S(sect,'D5',
      msg_var_notavailable);
    L_E1.Caption:=R2S(sect,'E1',
      'Download-Site:');
    L_F1.Caption:=R2S(sect,'F1',
      'For questions/suggestions go to OverDrive''s DVB board:');
    L_G1.Caption:=R2S(sect,'G1',
      'Contact at:');
    L_H1.Caption:=R2S(sect,'H1',
      'Please write only in German OR English');
    L_Lang.Caption:=R2S(sect,'Label_LANGUAGE',
      'Language-Credits:');
    B_Close.Caption:=R2S(sect,'Button_CLOSE',
      'Close');
  End;
End;

procedure Translate_LiveInetScan;
var sect:String;
Begin
  if NoIni Then Exit;
  With LiveInetClass Do
  With LiveInetScanClass Do
  Begin
    //now we try to translate Captions, Hints,...
    sect:='MAC-Scan-Dialog';
    Caption:=R2S(sect,'Dialog_NAME',
      'MediaAccessControll-Address settings');
    StartCaption:=R2S(sect,'Button_SCAN_START',
      'Start scan');
    StopCaption:=R2S(sect,'Button_SCAN_STOP',
      'Stop scan');
    B_scan.Caption:=StartCaption;
    L_LSort.Caption:=R2S(sect,'Label_SORTBY',
      'Sort by');
    RB_freq.Caption:=R2S(sect,'RadioButton_FREQUENCY',
      'a) frequency');
    RB_freq.Hint:=R2S(sect,'RadioButton_FREQUENCY_INFO',
      'Sort MACs by number of repeats');
    RB_number.Caption:=R2S(sect,'RadioButton_NUMBER',
      'b) number');
    RB_number.Hint:=R2S(sect,'RadioButton_NUMBER_INFO',
      'Sort MACs alphabetically');
    L_LCur.Caption:=R2S(sect,'Label_CURRENTENTRY',
      'Current entry:');
    L_Lfrequ.Caption:=R2S(sect,'Label_FREQUENCY',
      'Frequency:');
    L_LMAC.Caption:=R2S(sect,'Label_MACADDRESS',
      'MAC-Address:');
    GB_MACScan.Caption:=R2S(sect,'Box_NAME_MAC_SCAN',
      'MAC-Scanner');
    GB_MACEdit.Caption:=R2S(sect,'Box_NAME_MAC_EDIT',
      'MAC Edit Box');
    GB_MMACFilter.Caption:=R2S(sect,'Box_NAME_MAC_LIST',
      'Multi MAC filter list');
    B_ClearMAC.Caption:=R2S(sect,'Button_CLEAR_MAC',
      'Reset MAC');
    B_AddMAC.Caption:=R2S(sect,'Button_ADD_MAC',
      'Add MAC');
    B_UpdateMAC.Caption:=R2S(sect,'Button_UPDATE_MAC',
      'Update MAC');
    B_DelMAC.Caption:=R2S(sect,'Button_DELETE_MAC',
      'Delete MAC');
    B_DelAllMACs.Caption:=R2S(sect,'Button_DELETE_ALL_MAC',
      'Delete all MAC''s');
    BB_Close.Caption:=R2S(sect,'Button_CLOSE',
      'Close');
    L_current.Caption:=msg_var_notavailable;
    L_freq.Caption:=msg_var_notavailable;
  End;
End;

End.
