unit UScan;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, USRImport, Hex, ExtCtrls;

type
  TLiveInetScanClass = class(TForm)
    GB_MACScan: TGroupBox;
    L_LSort: TLabel;
    L_LCur: TLabel;
    L_Lfrequ: TLabel;
    L_current: TLabel;
    L_freq: TLabel;
    B_scan: TButton;
    LB_MAC: TListBox;
    RB_freq: TRadioButton;
    RB_number: TRadioButton;
    T_wait: TTimer;
    GB_MACEdit: TGroupBox;
    B_AddMAC: TButton;
    GB_MMACFilter: TGroupBox;
    LB_MMAC: TListBox;
    B_DelMAC: TButton;
    B_DelAllMACs: TButton;
    BB_Close: TBitBtn;
    E_MAC4: TEdit;
    E_MAC0: TEdit;
    Label20: TLabel;
    E_MAC1: TEdit;
    Label21: TLabel;
    E_MAC2: TEdit;
    Label22: TLabel;
    E_MAC3: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    E_MAC5: TEdit;
    B_UpdateMAC: TButton;
    B_ClearMAC: TButton;
    L_LMAC: TLabel;
    procedure BB_CloseClick(Sender: TObject);
    procedure RB_numberClick(Sender: TObject);
    procedure RB_freqClick(Sender: TObject);
    procedure LB_MACClick(Sender: TObject);
    procedure B_scanClick(Sender: TObject);
    procedure T_waitTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure E_MAC0KeyPress(Sender: TObject; var Key: Char);
    procedure B_ClearMACClick(Sender: TObject);
    procedure B_AddMACClick(Sender: TObject);
    procedure B_DelMACClick(Sender: TObject);
    procedure B_DelAllMACsClick(Sender: TObject);
    procedure LB_MMACClick(Sender: TObject);
    procedure B_UpdateMACClick(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
    StartCaption,StopCaption:String;
  end;

var
  LiveInetScanClass: TLiveInetScanClass;

implementation

uses ULiveInet, ULanguage;

{$R *.DFM}
const MAXMAC=10000;

type TMACArr=Record
               mac:Int64;
               freq:Word;
             End;
var MACArr:Array [0..MAXMAC-1] Of TMACArr;
    Filternum2:DWord;

procedure TLiveInetScanClass.BB_CloseClick(Sender: TObject);
begin
  Hide;  
end;

procedure TLiveInetScanClass.LB_MACClick(Sender: TObject);
var s:string;
begin
  L_current.Caption:=IntToStr(LB_MAC.ItemIndex+1);
  L_freq.Caption:=IntToStr(MACArr[LB_MAC.ItemIndex].freq);
  s:=LB_MAC.Items[LB_MAC.ItemIndex];
  E_MAC0.Text:=Copy(s,1,2);
  E_MAC1.Text:=Copy(s,4,2);
  E_MAC2.Text:=Copy(s,7,2);
  E_MAC3.Text:=Copy(s,10,2);
  E_MAC4.Text:=Copy(s,13,2);
  E_MAC5.Text:=Copy(s,16,2);
end;

function  GetMACAddress(p:PByteArray):Int64;
var off:Word;
    bp:BytePointer;
Begin
  {MAC = MediaAccessControl-Address}
  off:=3;{offset for MAC-Address}
  Result:=0;//clean return value
  bp:=@Result;// set bp to address of return value
  bp^:=Byte(p[off+0]); Inc(bp); //Int64:(8 Byte):--X-----
  bp^:=Byte(p[off+1]); Inc(bp); //Int64:(8 Byte):---X----
  bp^:=Byte(p[off+5]); Inc(bp); //Int64:(8 Byte):----X---
  bp^:=Byte(p[off+6]); Inc(bp); //Int64:(8 Byte):-----X--
  bp^:=Byte(p[off+7]); Inc(bp); //Int64:(8 Byte):------X-
  bp^:=Byte(p[off+8]);          //Int64:(8 Byte):-------X
  {e.g. MAC 00-02-C1-AB-CD-EF --> $000002C1ABCDEF (Int64)}
End;

function Pos3E(p:PByteArray;len:Integer):Integer;
var i:Integer;
    p1,
//    p2,
    p3:BytePointer;
//    b:Byte;
{DO NOT CHANGE ANYTHING IF YOU DON'T KNOW WHAT THIS IS FOR!}
{Be careful with INPUT-len/pointers!!!}
Begin
  Result:=-1;//if nothing is found...(similar to old Pos(s2,s))
  p1:=@p[0];
//  p2:=@p[1];
  p3:=@p[5];
//  b:=$70;
  For i:=0 To len-1 Do //we check for MPE-Header now
    if ( p1^         =$3E) And
//       ((p2^) And $F0= b ) And
       ( p3^         =$C1) // may be "C1" will be removed
       Then //MPE-Header is Okay!!
         Begin
           Result:=i;
           Break;//stop loop now!!
         End
        Else
         Begin
           Inc(p1);
//           Inc(p2);
           Inc(p3);
         End;
End;

//This input-procedure is used for getting MAC's and
//statistics for them
procedure CallBackScan(var buf;len_in:Integer);stdcall;
var i,j,len:Integer;
    mac:Int64;
    s:String;
    p:PByteArray;
Begin
// its not necessary to cache packet-parts, so this
// procedure is much more simple than the "real" CallBack's
  len:=len_in;
  p:=@buf;
  j:=0;
  Repeat
    i:=Pos3E(@p[j],len);
    //be sure that we can read the mac-address
    if (i=-1) Or (i+j+13>len) Then Exit;
    // mac seem to be ok
    mac:=GetMACAddress(@p[i+j]);
    s:=Copy(Hex64(mac),5,12);
    s:=Copy(s,1,2)+' '+Copy(s,3,2)+' '+Copy(s,5,2)+' '+
       Copy(s,7,2)+' '+Copy(s,9,2)+' '+Copy(s,11,2);
    Inc(j,i+1);Dec(len,i+1);
    i:=LiveInetScanClass.LB_MAC.Items.IndexOf(s);
    if i=-1 Then
      Begin
        LiveInetScanClass.LB_MAC.Items.Add(s);
        if LiveInetScanClass.LB_MAC.Items.Count>=MAXMAC Then
          Exit;
        if LiveInetScanClass.LB_MAC.Items.Count>=MAXMAC-1 Then
          //too much for now...
          LiveInetScanClass.B_scanClick(NIL);
        MACArr[LiveInetScanClass.LB_MAC.Items.Count-1].
          freq:=1;
        MACArr[LiveInetScanClass.LB_MAC.Items.Count-1].
          mac:=mac;
      End
     Else
      Begin
        Inc(MACArr[i].freq);
      End;
  Until len<=0;
End;

procedure SortMACs;

procedure QSortFreq(l,r:Integer);
var i,j,x:Integer;
    s_temp:String;
    temp:TMACArr;
Begin
  i:=l;
  j:=r;
  x:=MACArr[(l+r) DIV 2].freq;
  Repeat
    While (MACArr[i].freq>x) Do
      Inc(i);
    While (x>MACArr[j].freq) Do
      Dec(j);
    if (i<=j) Then
      With LiveInetScanClass Do
        Begin
          temp:=MACArr[i];
          s_temp:=LB_MAC.Items[i];
          MACArr[i]:=MACArr[j];
          LB_MAC.Items[i]:=LB_MAC.Items[j];
          MACArr[j]:=temp;
          LB_MAC.Items[j]:=s_temp;
          Inc(i);
          Dec(j);
        End;
  Until (i>j);
  if (l<j) Then QSortFreq(l,j);
  if (i<r) Then QSortFreq(i,r);
end;

procedure QSortMAC(l,r:Integer);
var i,j:Integer;
    x:Int64;
    s_temp:String;
    temp:TMACArr;
Begin
  i:=l;
  j:=r;
  x:=MACArr[(l+r) DIV 2].mac;
  With LiveInetScanClass Do
  Repeat
    While (MACArr[i].mac<x) Do
      Inc(i);
    While (x<MACArr[j].mac) Do
      Dec(j);
    if (i<=j) Then
      Begin
        temp:=MACArr[i];
        s_temp:=LB_MAC.Items[i];
        MACArr[i]:=MACArr[j];
        LB_MAC.Items[i]:=LB_MAC.Items[j];
        MACArr[j]:=temp;
        LB_MAC.Items[j]:=s_temp;
        Inc(i);
        Dec(j);
      End;
  Until (i>j);
  if (l<j) Then QSortMAC(l,j);
  if (i<r) Then QSortMAC(i,r);
end;

Begin //sort MACs
//  CompareStr();
  if LiveInetScanClass.RB_freq.Checked Then
    QSortFreq(0,LiveInetScanClass.LB_MAC.Items.Count-1)
   Else
    QSortMAC(0,LiveInetScanClass.LB_MAC.Items.Count-1);
End;

procedure TLiveInetScanClass.B_scanClick(Sender: TObject);
var i:Integer;
begin
  if B_scan.Caption=StartCaption Then
    Begin //scan begins...
      B_scan.Enabled:=False;
      
      For i:=0 To MAXMAC-1 Do
        MACArr[i].freq:=0;
      LB_MAC.Clear;
      if not SetFilter(StrToInt(LiveInetClass.E_PID.Text),
        @CallBackScan,2,2,@Filternum2) Then
        Begin
          MessageDlg(LiveInetClass.msg_err_setfilterd,
                     mtError,[mbOk], 0);
          B_scan.Caption:=StartCaption;
          B_scan.Enabled:=True;
          Exit;
        End;
      LiveInetClass.B_start.Enabled:=False;
      B_scan.Caption:=StopCaption;
      T_wait.Enabled:=True;
    End
   Else
    Begin //Stop scan
      B_scan.Enabled:=False;
      if not DelFilter(Filternum2) Then
        MessageDlg(LiveInetClass.msg_err_delfilter,
                   mtError,[mbOk], 0);
      B_scan.Caption:=StartCaption;
      T_wait.Enabled:=True;
      SortMACs;
      LiveInetClass.B_start.Enabled:=True;
      LB_MAC.ItemIndex:=-1;
    End;
end;

procedure TLiveInetScanClass.RB_numberClick(Sender: TObject);
begin
  LB_MAC.ItemIndex:=0;
  SortMACs;
  L_current.Caption:=LiveInetClass.msg_var_notavailable;
  L_freq.Caption:=LiveInetClass.msg_var_notavailable;
  LB_MAC.ItemIndex:=-1;
end;

procedure TLiveInetScanClass.RB_freqClick(Sender: TObject);
begin
  LB_MAC.ItemIndex:=0;
  SortMACs;
  L_current.Caption:=LiveInetClass.msg_var_notavailable;
  L_freq.Caption:=LiveInetClass.msg_var_notavailable;
  LB_MAC.ItemIndex:=-1;
end;

procedure TLiveInetScanClass.T_waitTimer(Sender: TObject);
begin
  B_scan.Enabled:=True;
  T_wait.Enabled:=False;
end;

procedure TLiveInetScanClass.FormCreate(Sender: TObject);
begin
  Translate_LiveInetScan;
end;

procedure TLiveInetScanClass.E_MAC0KeyPress(Sender: TObject;
  var Key: Char);
begin
  Key:=UpCase(Key);
  if ((Ord(key)<48) Or (Ord(key)>57)) And
     ((Ord(key)<65) Or (Ord(key)>70)) And (key<>#8) Then
    Begin
      ShowMessage(LiveInetClass.msg_err_onlyhexvalues);
      key:=#0; //delete key value
    End;
end;

procedure TLiveInetScanClass.B_ClearMACClick(Sender: TObject);
begin
  E_MAC0.Text:='00';
  E_MAC1.Text:='00';
  E_MAC2.Text:='00';
  E_MAC3.Text:='00';
  E_MAC4.Text:='00';
  E_MAC5.Text:='00';
end;

procedure TLiveInetScanClass.B_AddMACClick(Sender: TObject);
var s:String;
begin
  s:=E_MAC0.Text+' '+E_MAC1.Text+' '+E_MAC2.Text+' '+
     E_MAC3.Text+' '+E_MAC4.Text+' '+E_MAC5.Text;
  if (LB_MMAC.Items.IndexOf(s)>-1) Then
    Begin
      MessageDlg(LiveInetClass.msg_wng_filterexists,
                 mtWarning,[mbOk], 0);
      Exit;
    End;
  if LiveInetClass.AddMACFilter(s) Then
    Begin
      LB_MMAC.Items.Add(s);
      B_DelAllMACs.Enabled:=True;
    End
   Else
    MessageDlg(LiveInetClass.msg_wng_setfiltere+
               IntToStr(LB_MMAC.Items.Count+1),
               mtWarning,[mbOk], 0);
end;

procedure TLiveInetScanClass.B_DelMACClick(Sender: TObject);
begin
  if Not LiveInetClass.DelMACFilter(LB_MMAC.ItemIndex+1) Then
    MessageDlg(LiveInetClass.msg_err_delfilter,
               mtError,[mbOk], 0);
  LB_MMAC.Items.Delete(LB_MMAC.ItemIndex);
  if (LB_MMAC.Items.Count=0) Then
    B_DelAllMACs.Enabled:=False;
  B_DelMAC.Enabled:=False;
  B_UpdateMAC.Enabled:=False;
  B_ClearMAC.Click;
end;

procedure TLiveInetScanClass.B_DelAllMACsClick(Sender: TObject);
var i:Integer;
begin
  For i:=LB_MMAC.Items.Count DownTo 1 Do
    Begin
      if Not LiveInetClass.DelMACFilter(i) Then
        MessageDlg(LiveInetClass.msg_err_delfilter,
                   mtError,[mbOk], 0);
      LB_MMAC.Items.Delete(i-1);
    End;
  B_DelMAC.Enabled:=False;
  B_UpdateMAC.Enabled:=False;
  B_DelAllMACs.Enabled:=False;
end;

procedure TLiveInetScanClass.LB_MMACClick(Sender: TObject);
var s:string;
begin
  B_DelMAC.Enabled:=True;
  B_UpdateMAC.Enabled:=True;
  s:=LB_MMAC.Items[LB_MMAC.ItemIndex];
  E_MAC0.Text:=Copy(s, 1,2);
  E_MAC1.Text:=Copy(s, 4,2);
  E_MAC2.Text:=Copy(s, 7,2);
  E_MAC3.Text:=Copy(s,10,2);
  E_MAC4.Text:=Copy(s,13,2);
  E_MAC5.Text:=Copy(s,16,2);
end;

procedure TLiveInetScanClass.B_UpdateMACClick(Sender: TObject);
var s:String;
begin
  s:=E_MAC0.Text+' '+E_MAC1.Text+' '+E_MAC2.Text+' '+
     E_MAC3.Text+' '+E_MAC4.Text+' '+E_MAC5.Text;
  if (s=LB_MMAC.Items[LB_MMAC.ItemIndex]) Then
    Begin //nothing to change... (user plays)
      B_UpdateMAC.Enabled:=False;
      B_ClearMAC.Click;
      Exit;
    End;
  if (LB_MMAC.Items.IndexOf(s)>-1) Then
    Begin //filter not possible (already exists!)
      MessageDlg(LiveInetClass.msg_wng_filterexists,
                 mtWarning,[mbOk], 0);
      Exit;
    End;
  B_UpdateMAC.Enabled:=False;
  B_DelMAC.Enabled:=False;
  B_ClearMAC.Click;
  if LiveInetClass.UpdMACFilter(s,LB_MMAC.ItemIndex+1) Then
    LB_MMAC.Items[LB_MMAC.ItemIndex]:=s
   Else
    MessageDlg(LiveInetClass.msg_wng_setfiltere+
               IntToStr(LB_MMAC.ItemIndex+1),
               mtWarning,[mbOk], 0);
end;

end.
